{------------------------------------------------------------}
{-	 FlashPac Pascal Library (Bios Unit) - V3.5	    -}
{-	(c) Copyright 1986-1991 - All Rights Reserved	    -}
{-                     SimpleSoft Inc                       -}
{-                     1209 Poplar St                       -}
{-                 La Crescent, MN 55947                    -}
{------------------------------------------------------------}

Unit FPBios;
Interface
{$B-,F+}
{$IFNDEF VER40}
{D-}
{$ENDIF}

{--------------------------------------------------------------------}
Type
   ByteArry17 = Array[1..17] Of Byte;

Procedure bvSetMode( Mode, Clear : Integer );
Procedure bvSetCurType( StScan, SpScan : Integer );
Procedure bvSetCurPos( pg, row, col : Integer );

Procedure bvGetCurPos(	   pg  : Integer;
		       Var row : Integer;
		       Var col : Integer );

Procedure bvGetCurType(     pg	   : Integer;
			Var stscan : Integer;
			Var spscan : Integer );

Procedure bvSetPage( pg : Integer );

Procedure bvScrollUp( top,    left,
		      bottom, right,
		      lines,  attr : Integer );

Procedure bvScrollDn( top,    left,
		      bottom, right,
		      lines,  attr : Integer );

Procedure bvReadCell( Var ch   : Integer;
		      Var attr : Integer;
			  pg   : Integer );

Procedure bvWrtNCell( ch, attr, count, pg : Integer );

Procedure bvWrtNChar( ch, count, pg : Integer );
Procedure bvSetState0B( color : Integer );
Procedure bvWrtPix( row, col, pixval, pg : Integer );
Function  bvReadPix( row, col, pg : Integer ) : Integer;
Procedure bvWrtTTYChar( ch, pg, color : Integer );
Procedure bvGetMode( Var mode, cols, pg : Integer );
Procedure bvSetPalReg( color, reg : Integer );
Procedure bvSetBorder( color : Integer );

Procedure bvSetPalBorder( list : ByteArry17 );

Procedure bvSetBlink( state : Integer );
Function  bvGetPalReg( reg : Integer) : Integer;
Function  bvGetBorder : Integer;

Procedure bvGetPalBorder( buf : ByteArry17 );

Procedure bvSetColorReg( colorreg : Word;
			 green	  : Integer;
			 blue	  : Integer;
			 red	  : Integer );

Procedure bvSetColorRegBlk(	startreg : Word;
				regcount : Integer;
			    Var colortbl	  );

Procedure bvSetColorPgMode( pgstate : Integer );
Procedure bvSetColorRegPg( pg : Integer );

Procedure bvGetColorReg(     colorreg : Integer;
			 Var green    : Integer;
			 Var blue     : Integer;
			 Var red      : Integer );

Procedure bvGetColorRegBlk(	startreg : Word;
				regcount : Integer;
			    Var colortbl	   );

Procedure bvGetColorPgMode( Var colorpg : Integer;
			    Var pgmode	: Integer );

Procedure bvSetGrayScale( startreg : Word;
			  regcount : Integer );

Procedure bvLoadUsrFont00(     pts,
			       block	: Integer;
			       chcount,
			       startch	: Word;
			   Var fonttbl		  );

Procedure bvLoadUsrFont10(     pts,
			       block	: Integer;
			       chcount,
			       startch	: Word;
			   Var fonttbl		  );

Procedure bvLoad8x14Font01( block : Integer );
Procedure bvLoad8x14Font11( block : Integer );
Procedure bvLoad8x8Font02( block : Integer );
Procedure bvLoad8x8Font12( block : Integer );

Procedure bvSetBlkSpec( block : Integer );

Procedure bvLoad8x16Font04( block : Integer );
Procedure bvLoad8x16Font14( block : Integer );

Procedure bvSet1FhFontPtr( Var fonttbl	     );


Procedure bvSet43hUsrFont(     rows    : Integer;
			       points  : Word;
			       scnrows : Integer;
			   Var fonttbl		 );

Procedure bvSet43h8x14Font( rows, scnrows : Integer  );
Procedure bvSet43h8x8Font( rows, scnrows : Integer );
Procedure bvSet43h8x16Font( rows, scnrows : Integer );

Procedure bvGetFontInfo(     fontcode : Integer;
			 Var points   : Word;
			 Var scnrows  : Integer;
			 Var fonttbl		 );

Procedure bvGetConfigInfo( Var dsptype : Integer;
			   Var egamem  : Integer;
			   Var fbits   : Integer;
			   Var swset   : Integer );

Procedure bvSetAltPrtSc;
Function  bvSetScanLines( scancode : Integer ) : Integer;
Function  bvDefPalLoad( setting : Integer ) : Integer;
Function  bvVioAccess( setting : Integer ) : Integer;
Function  bvGrayScaleSum( setting : Integer ) : Integer;
Function  bvCurEmulation( setting : Integer ) : Integer;
Procedure bvSwDsp( setting : Integer; Var buffer     );
Function  bvScnRefresh( setting : Integer ) : Integer;

Procedure bvWrtTTYStr(	   mode : Integer;
			   row	: Integer;
			   col	: Integer;
			   len	: Integer;
			   pg	: Integer;
			   attr : Integer;
		       Var st		 );

{--------------------------------------------------------------------}
{-                                                                  -}
{--------------------------------------------------------------------}

Implementation

Const
   Copyright1 = 'FlashPac Bios Lib (Pascal) - V3.5';
   Copyright2 = '(c) Copyright 1986-1991 - All Rights Reserved';
   Copyright3 = 'SimpleSoft, Inc.';
   Copyright4 = '1209 Poplar St';
   Copyright5 = 'La Crescent, MN 55947';
   Copyright6 = '(507) 895-8237';

{$L viobios\b1000XXD }	Procedure bvSetMode;		   External;
{$L viobios\b100100D }	Procedure bvSetCurType; 	   External;
{$L viobios\b100200D }	Procedure bvSetCurPos;		   External;
{$L viobios\b100300D }	Procedure bvGetCurPos;		   External;
{$L viobios\b1003X0D }	Procedure bvGetCurType; 	   External;
{$L viobios\b100500D }	Procedure bvSetPage;		   External;
{$L viobios\b1006XXD }	Procedure bvScrollUp;		   External;
                        Procedure bvScrollDn;              External;
{$L viobios\b100800D }	Procedure bvReadCell;		   External;
{$L viobios\b100900D }	Procedure bvWrtNCell;		   External;
{$L viobios\b100A00D }	Procedure bvWrtNChar;		   External;
{$L viobios\b100B00D }	Procedure bvSetState0B; 	   External;
{$L viobios\b100C00D }	Procedure bvWrtPix;		   External;
{$L viobios\b100D00D }	Function  bvReadPix;		   External;
{$L viobios\b100E00D }	Procedure bvWrtTTYChar; 	   External;
{$L viobios\b100F00D }	Procedure bvGetMode;		   External;
{$L viobios\b101000D }	Procedure bvSetPalReg;		   External;
{$L viobios\b101001D }	Procedure bvSetBorder;		   External;
{$L viobios\b101002D }	Procedure bvSetPalBorder;	   External;
{$L viobios\b101003D }	Procedure bvSetBlink;		   External;
{$L viobios\b101007D }	Function  bvGetPalReg;		   External;
{$L viobios\b101008D }	Function  bvGetBorder;		   External;
{$L viobios\b101009D }	Procedure bvGetPalBorder;	   External;
{$L viobios\b101010D }	Procedure bvSetColorReg;	   External;
{$L viobios\b101012D }	Procedure bvSetColorRegBlk;	   External;
{$L viobios\b101013D }	Procedure bvSetColorPgMode;	   External;
                        Procedure bvSetColorRegPg;	   External;
{$L viobios\b101015D }	Procedure bvGetColorReg;	   External;
{$L viobios\b101017D }	Procedure bvGetColorRegBlk;	   External;
{$L viobios\b10101AD }	Procedure bvGetColorPgMode;	   External;
{$L viobios\b10101BD }	Procedure bvSetGrayScale;	   External;
{$L viobios\b101100D }	Procedure bvLoadUsrFont00;	   External;
                        Procedure bvLoadUsrFont10;	   External;
{$L viobios\b101101D }	Procedure bvLoad8x14Font01;	   External;
                        Procedure bvLoad8x14Font11;	   External;
{$L viobios\b101102D }	Procedure bvLoad8x8Font02;	   External;
                        Procedure bvLoad8x8Font12;	   External;
{$L viobios\b101103D }	Procedure bvSetBlkSpec; 	   External;
{$L viobios\b101104D }	Procedure bvLoad8x16Font04;	   External;
                        Procedure bvLoad8x16Font14;	   External;
{$L viobios\b101120D }	Procedure bvSet1FhFontPtr;	   External;
{$L viobios\b101121D }	Procedure bvSet43hUsrFont;	   External;
{$L viobios\b101122D }	Procedure bvSet43h8x14Font;	   External;
{$L viobios\b101123D }	Procedure bvSet43h8x8Font;	   External;
{$L viobios\b101124D }	Procedure bvSet43h8x16Font;	   External;
{$L viobios\b101130D }	Procedure bvGetFontInfo;	   External;
{$L viobios\b101210D }	Procedure bvGetConfigInfo;	   External;
{$L viobios\b101220D }	Procedure bvSetAltPrtSc;	   External;
{$L viobios\b101230D }	Function  bvSetScanLines;	   External;
{$L viobios\b101231D }	Function  bvDefPalLoad; 	   External;
{$L viobios\b101232D }	Function  bvVioAccess;		   External;
{$L viobios\b101233D }	Function  bvGrayScaleSum;	   External;
{$L viobios\b101234D }	Function  bvCurEmulation;	   External;
{$L viobios\b101235D }	Procedure bvSwDsp;		   External;
{$L viobios\b101236D }	Function  bvScnRefresh; 	   External;
{$L viobios\b1013XXD }	Procedure bvWrtTTYStr;		   External;

{--------------------------------------------------------------------}

Begin
end.
