{------------------------------------------------------------}
{-       FlashPac Pascal Library (Disk Unit) - V3.5         -}
{-      (c) Copyright 1986-1991 - All Rights Reserved       -}
{-                     SimpleSoft Inc                       -}
{-                     1209 Poplar St                       -}
{-                 La Crescent, MN 55947                    -}
{------------------------------------------------------------}

Unit FPDisk;
Interface
{$B-,F+}
{$IFNDEF VER40}
{D-}
{$ENDIF}
Const
   DosErrNo   : Integer   =  0;
   CErrCode   : Integer   =  0;
   CErrType   : Integer   = -1;
   CErrDrive  : Integer   = -1;
   CErrDevice : String[8] = '';

Type
   TFindRec = Record
                 Attr : Word;
                 Time : Word;
                 Date : Word;
                 Size : LongInt;
                 Name : String[12];
              End;

{--------------------------------------------------------------------}
{-                                                                  -}
{--------------------------------------------------------------------}

   Procedure CloseFile(Handle : Integer);
   Procedure CreateFile(    Path   : String;
                            Attr   : Integer;
                        Var Handle : Integer);
   Procedure DosFindFirst(    Path    : String;
                              Attr    : Integer;
                          Var FindRec : TFindRec);
   Procedure DosFindNext(Var FindRec : TFindRec);
   Function  FSeek(Handle,Orgin : Integer; Offset : LongInt) : LongInt;
   Function  GetDrive : Integer;
   Procedure GetDTA(Var Segment,Offset : Word);
   Function  GetNDrvs : Integer;
   Function  GetFileSize(Handle : Integer) : LongInt;
   Procedure OpenFile(    Path   : String;
                          Attr   : Integer;
                      Var Handle : Integer);
   Procedure ReadFile(    Handle,NBytes : Integer;
                      Var Buffer                 ;
                      Var RBytes        : Integer);
   Procedure ResetDisk;
   Procedure ResetErrCodes;
   Procedure RestInt24;
   Procedure SetDTA(Segment,Offset : Integer);
   Procedure SetInt24;
   Procedure WriteFile(    Handle,NBytes : Integer;
                       Var Buffer                 ;
                       Var WBytes        : Integer);

{--------------------------------------------------------------------}
{-                                                                  -}
{--------------------------------------------------------------------}

Implementation
Const
   SegInt24   : Word = 0;
   OfsInt24   : Word = 0;

   Copyright1 = 'FlashPac Pascal Library (Disk Unit) - V3.5';
   Copyright2 = '(c) Copyright 1986-1991 - All Rights Reserved';
   Copyright3 = 'SimpleSoft, Inc.';
   Copyright4 = '1209 Poplar St';
   Copyright5 = 'La Crescent, MN 55947';

   {$L disk\CloseFil}
   {$L disk\CreatFil}
   {$L disk\FSeek   }
   {$L disk\FindF   }
   {$L disk\FindN   }
   {$L disk\GetDrive}
   {$L disk\GetDTA  }
   {$L disk\GetNDrvs}
   {$L disk\GFilSize}
   {$L disk\OpenFile}
   {$L disk\ReadFile}
   {$L disk\ResetDsk}
   {$L disk\SetDTA  }
   {$L disk\SetInt24}
   {$L disk\WriteFil}

{--------------------------------------------------------------------}
{-                                                                  -}
{--------------------------------------------------------------------}

   Procedure CloseFile;        External;
   Procedure CreateFile;       External;
   Procedure DosFindFirst;     External;
   Procedure DosFindNext;      External;
   Function  FSeek;            External;
   Function  GetDrive;         External;
   Procedure GetDTA;           External;
   Function  GetNDrvs;         External;
   Function  GetFileSize;      External;
   Procedure OpenFile;         External;
   Procedure ReadFile;         External;
   Procedure ResetDisk;        External;
   Procedure ResetErrCodes;    External;
   Procedure RestInt24;        External;
   Procedure SetDTA;           External;
   Procedure SetInt24;         External;
   Procedure WriteFile;        External;

{--------------------------------------------------------------------}
{-                                                                  -}
{--------------------------------------------------------------------}

Begin
end.
