{------------------------------------------------------------}
{-       FlashPac Pascal Library (Video Unit) - V3.5        -}
{-      (c) Copyright 1986-1991 - All Rights Reserved       -}
{-                     SimpleSoft Inc                       -}
{-                     1209 Poplar St                       -}
{-                 La Crescent, MN 55947                    -}
{------------------------------------------------------------}

Unit FPVideo;
Interface
{$B-,F+}
{$IFNDEF VER40}
{D-}
{$ENDIF}
uses Crt,FPGetKey;

Const
   VioMode    : Word = 7;
   VioPage    : Word = 0;
   VioCols    : Word = 80;
   VioCursor  : Word = $0C0D;
   VioBaseSeg : Word = $B000;
   InsMode    : Word = 0;

Type
   TSet   = Set Of 0..255;

{--------------------------------------------------------------------}

   Procedure VioInit;
   Procedure BorderColor(Color : Integer);
   Procedure ClrWin(x1,y1,x2,y2,Attr : Integer);
   Procedure ColorMsg(x,y,Attr : Integer; St : String);
   Procedure DspMsg(x,y : Integer; St : String);

   Procedure EditSt(    Row,
                        St_Col,
                        Sp_Col,Len,
                        CaseInd,
                        FillCh,
                        AutoSkipInd,
                        ToneErr,
                        DurErr        : Integer;
                    Var VCSet,TCSet   : TSet;
                    Var ChOfs,TE      : Integer;
                    Var St            : String);

   Procedure FillColAttr(X,Y,NRows,Attr : Integer);
   Procedure FillColCell(X,Y,NRows : Integer; Cell : Word);
   Procedure FillColChar(X,Y,NRows : Integer; Ch : Char);

   Procedure FillFrameAttr(X1,Y1,X2,Y2,Attr : Integer);
   Procedure FillFrameCell(X1,Y1,X2,Y2 : Integer; Cell : Word);
   Procedure FillFrameChar(X1,Y1,X2,Y2 : Integer; Ch   : Char);

   Procedure FillRowAttr(X,Y,NBytes,Attr : Integer);
   Procedure FillRowCell(X,Y,NWords : Integer; Cell : Word);
   Procedure FillRowChar(X,Y,NBytes : Integer; Ch : Char);

   Procedure FrameWin(UL,UR,LL,LR,Hor,Ver : Char; Color : Integer);

   Procedure GetFrameAttr(X1,Y1,X2,Y2 : Integer; Var Buffer );
   Procedure GetFrameCell(X1,Y1,X2,Y2 : Integer; Var Buffer );
   Procedure GetFrameChar(X1,Y1,X2,Y2 : Integer; Var Buffer );

   Procedure GetScrn(X,Y,NWords : Integer;       Var Buffer );
   Procedure PutScrn(X,Y,NWords : Integer;       Var Buffer );

   Procedure PutFrameAttr(X1,Y1,X2,Y2 : Integer; Var Buffer );
   Procedure PutFrameCell(X1,Y1,X2,Y2 : Integer; Var Buffer );
   Procedure PutFrameChar(X1,Y1,X2,Y2 : Integer; Var Buffer );

   Function  GetCursorSize : Word;
   Procedure SetCursorSize(StScan,SpScan : Integer);
   Procedure HideCursor;
   Procedure ShowCursor;


   Function  GetVideoMode : Integer;
   Function  GetVideoCols : Integer;
   Function  GetVideoPage : Integer;
   Procedure GetVideoInfo(Var BaseSeg,Cols,Pg,Mode : Word);
   Procedure InitVideo(Mode : Integer);
   Function  RvsAttr(Attr : Integer) : Integer;
   Procedure SetVideoPage(PageNo : Integer);

   Procedure GotoxyAbs(X,Y : Integer);
   Function  WhereXAbs : Integer;
   Function  WhereYAbs : Integer;

   Procedure ScrollLeft(X1,Y1,X2,Y2,Attr,NCols : Integer);
   Procedure ScrollRight(X1,Y1,X2,Y2,Attr,NCols : Integer);
   Procedure ScrollUp(X1,Y1,X2,Y2,Attr,NRows : Integer);
   Procedure ScrollDown(X1,Y1,X2,Y2,Attr,NRows : Integer);

   Procedure WindowFP(X1,Y1,X2,Y2 : Integer);
   Procedure WriteSt(St : String);
   Procedure WriteStLn(St : String);

{--------------------------------------------------------------------}
{-                                                                  -}
{--------------------------------------------------------------------}

Implementation

Const
   Copyright1 = 'FlashPac Pascal Library (Video Unit) - V3.5';
   Copyright2 = '(c) Copyright 1986-1991 - All Rights Reserved';
   Copyright3 = 'SimpleSoft, Inc.';
   Copyright4 = '1209 Poplar St';
   Copyright5 = 'La Crescent, MN 55947';

   {$L video\VioInit }
   {$L video\Border  }
   {$L video\ClrWin  }
   {$L video\ColorMsg}
   {$L video\Calcxy  }
   {$L video\DspMsg  }
   {$L video\EditSt  }

   {$L video\FColByte}
   {$L video\FColCell}

   {$L video\FramByte}
   {$L video\FramCell}

   {$L video\FRowByte}
   {$L video\FRowCell}

   {$L video\FrameWin}
   {$L video\GFramByt}

   {$L video\GScrn   }
   {$L video\PScrn   }

   {$L video\PFramByt}

   {$L video\GCurSize}
   {$L video\SCurSize}
   {$L video\HCursor }
   {$L video\SCursor }

   {$L video\RvsAttr }

   {$L video\GVioMode}
   {$L video\GVioCols}
   {$L video\GVioPage}
   {$L video\GVioInfo}
   {$L video\InitVio }

   {$L video\SVioPage}
   {$L video\GotoxyAb}
   {$L video\WhereXAb}
   {$L video\WhereYAb}

   {$L video\ScrollLt}
   {$L video\ScrollRt}
   {$L video\ScrollVt}

   {$L video\WindowFP}
   {$L video\WrtSt   }
   {$L video\WrtStLn }

   {$L video\DspMem1 }
   {$L video\DspMem2 }
   {$L video\DspReg1 }
   {$L video\DspReg2 }
   {$L video\ReadMem1}
   {$L video\ReadMem2}

{--------------------------------------------------------------------}

   Procedure VioInit;          External;
   Procedure BorderColor;      External;
   Procedure ClrWin;           External;
   Procedure ColorMsg;         External;
   Function  Calcxy : Integer; External;
   Procedure DspMsg;           External;
   Procedure EditSt;           External;

   Procedure FillColAttr;      External;
   Procedure FillColCell;      External;
   Procedure FillColChar;      External;

   Procedure FillFrameAttr;    External;
   Procedure FillFrameCell;    External;
   Procedure FillFrameChar;    External;

   Procedure FillRowAttr;      External;
   Procedure FillRowCell;      External;
   Procedure FillRowChar;      External;

   Procedure FrameWin;         External;

   Procedure GetFrameAttr;     External;
   Procedure GetFrameCell;     External;
   Procedure GetFrameChar;     External;

   Procedure GetScrn;          External;
   Procedure PutScrn;          External;

   Procedure PutFrameAttr;     External;
   Procedure PutFrameCell;     External;
   Procedure PutFrameChar;     External;

   Function  GetCursorSize;    External;
   Procedure SetCursorSize;    External;
   Procedure HideCursor;       External;
   Procedure ShowCursor;       External;

   Function  RvsAttr;          External;

   Function  GetVideoMode;     External;
   Function  GetVideoCols;     External;
   Function  GetVideoPage;     External;
   Procedure GetVideoInfo;     External;
   Procedure InitVideo;        External;

   Procedure SetVideoPage;     External;
   Procedure GotoxyAbs;        External;
   Function  WhereXAbs;        External;
   Function  WhereYAbs;        External;

   Procedure ScrollLeft;       External;
   Procedure ScrollRight;      External;
   Procedure ScrollUp;         External;
   Procedure ScrollDown;       External;

   Procedure WindowFP;         External;
   Procedure WriteSt;          External;
   Procedure WriteStLn;        External;

   Procedure VioDspReg1;       External;
   Procedure VioDspReg2;       External;
   Procedure VioDspMem1;       External;
   Procedure VioDspMem2;       External;
   Procedure VioReadMem1;      External;
   Procedure VioReadMem2;      External;

{--------------------------------------------------------------------}

Begin
   VioInit;
end.
